package riddle;

# riddles

our %RID = (
	"wind"	=> <<EOF,
\nVoiceless it cries,
Wingless flutters,
Toothless bites,
Mouthless mutters.
EOF
	"mountain"=> <<EOF,
\nWhat has roots as nobody sees
Is taller than trees,
Up it goes,
And yet never grows?
EOF
	"teeth"	=> <<EOF,
\nThirty white horses on a red hill
First they champ,
Then they stamp
Then they stay still.
EOF
	"egg"	=> <<EOF,
\nA box without hinges, key or lid,
Yet golden treasure inside is hid.
EOF
	"fish"	=> <<EOF,
\nAlive without breath,
As cold as death;
Never thirsty, ever drinking,
All in mail never clinking.
EOF
	"time"	=> <<EOF,
\nThis thing all things devours: 
Birds, beasts, trees, flowers;
Gnaws iron, bites steel;
Grinds hard stones to meal;
Slays king, ruins town,
And beats high mountain down.
EOF

);

our @ANS = keys %RID;

#======================
# object related

# old-style object in a hash
sub new {
    my $pkg = shift;
    my $class = ref $pkg || $pkg;
    my $h = { riddle=> $ANS[rand $#ANS + 1] , state => 0 };
    print STDERR "Creating new object from thingy: $h\n";
    bless $h, $class;
}

sub new_riddle {
    my $this = shift;
    $this->state(0);
    $this->{riddle} = $ANS[ rand $#ANS + 1];
}

sub riddle_text {
    return $RID{ shift->{riddle} };
}

sub riddle {
    return shift->{riddle};
}

sub state {
# 0 guessing, 1 guessed
    my $this = shift;
    return $this->{state} unless @_;
    $this->{state} = $_[0];
}

sub guess {
    my $this = shift;
    die "Guessed already" if $this->state();
    my $ans = shift;
    my $r = $this->riddle();

    if ( $ans =~ /^$r/i ) {
    	$this->state(1);
	return 1;
    }
}

# riddle protocol
sub protocol {
    my $this = shift;
    my $msg_in = shift; 
    my $msg_out;

    return undef if $msg_in && $msg_in =~ /^(quit|exit)/i;
    if ( $this->guess($msg_in) ) {
	$msg_out = "Good guess!\nNew riddle:\n";
	$this->new_riddle();
    } elsif ($msg_in) {
	$msg_out = "Try again!\n";
    } else {
	$msg_out = "Make a guess!\n";
    }

    $msg_out .= $this->riddle_text;
    return $msg_out;
}

1;
